#ifndef PKGGLB_H
#define PKGGLB_H
//===========================================================================
//PKGGLB.H HEADER Puppy-Package-Handler Global Declarations
//===========================================================================
//===========================================================================
//GLOBAL NAMED-CONSTANTS
//===========================================================================
#define GLB_LITTLE_ENDIAN		//little-endian-addressing
#define GLB_NULL	0		//null

enum GLB_BOOL_E				//boolean enumeration
{
  GLB_BOO_FALSE		= 0,		//false
  GLB_BOO_TRUE		= 1		//true
};

enum GLB_RESULT_E			//result enumeration
{
  GLB_RSL_FAILURE	= 0,		//failure
  GLB_RSL_SUCCESS	= 1		//success
};

//===========================================================================
//GLOBAL TYPES
//===========================================================================
//common types
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned short ushort;

typedef uchar GLB_BOOL_T;		//boolean type
typedef uchar GLB_RESULT_T;		//result type

//===========================================================================
//GLOBAL MACROS
//===========================================================================
#define GLB_Max_M(a, b)		(((a) > (b))? (a): (b))
#define GLB_Min_M(a, b)		(((a) < (b))? (a): (b))

//automatic array-length
#define GLB_ArrayLength_M(x)	(sizeof(x) / sizeof((x)[0]))

//uchar conversions
#ifdef GLB_LITTLE_ENDIAN		//little-endian-addressing
#define GLB_BytesAsDWord_M(a, b, c, d)\
  ((ulong) ((a) | ((b) << 8) | ((ulong) (c) << 16) | ((ulong) (d) << 24)))
#define GLB_BytesAsWord_M(a, b) ((ushort) ((a) | ((b) << 8)))

#else //GLB_LITTLE_ENDIAN		//little-endian-addressing
#define GLB_BytesAsDWord_M(a, b, c, d)\
  ((ulong) (((d) | ((c) << 8) | ((b) << 16) | ((a) << 24)))
#define GLB_BytesAsWord_M(a, b) ((ushort) ((b) | ((a) << 8)))
#endif //GLB_LITTLE_ENDIAN		//little-endian-addressing

#endif //PKGGLB_H
